// utilities for communicating over the network 

static ReadBuffer comm_mkrbuffer(Communication *comm) {
	return mkrbuffer(comm->received, comm->recv_size);
}

static WriteBuffer comm_mkwbuffer(Communication *comm) {
	return mkwbuffer(comm->sending, COMM_MAX_BYTES);
}

// these are probably a bit excessive but better safe than sorry 
static void comm_stop_sending(Communication *comm) {
	comm->is_sending = false;
	comm->send_size = 0;
	comm->nsent = 0;
}
static void comm_stop_receiving(Communication *comm) {
	comm->is_receiving = false;
	comm->nbytes_of_size_received = 0;
	comm->nrecvd = 0;
}

static void comm_start_sending(Communication *comm, size_t send_size) {
	u8 *send_size_data = comm->send_data;
	comm->send_size = send_size;
	comm->is_sending = true;
	send_size_data[0] = send_size & 0xFF;
	send_size_data[1] = (send_size >> 8) & 0xFF;
	send_size_data[2] = (send_size >> 16) & 0xFF;
	send_size_data[3] = (send_size >> 24) & 0xFF;
	comm->nsent = 0;
}
static void comm_start_sending_wbuf(Communication *comm, WriteBuffer *b) {
	comm_start_sending(comm, buf_bytes_written(b));
}
static void comm_start_receiving(Communication *comm) {
	comm->is_receiving = true;
	comm->nbytes_of_size_received = 0;
}


